/*  ftplite 
    Ȩ(C)  2003

    һ GNU ͨù
֤޸ĺ·һ򡣻֤ĵڶ棬ߣѡ
κθµİ汾
    һĿϣãûκεûʺضĿ
ĵĵϸ GNU ͨù֤
    ӦѾͳһյһ GNU ͨù֤ĸûУ
дŸ
    The Free Software Foundation, Inc.,  675  Mass Ave,  Cambridge,
    MA02139,  USA

    ڱʲô⣬ϵ
    E-mailedyfox@sohu.com */
#ifndef _FTPSRV_APPEARED_
#define _FTPSRV_APPEARED_

#if defined(_DEBUG) && defined(_MSC_VER) && _MSC_VER < 1300
#pragma warning (disable: 4503)
#pragma warning (disable: 4786)
#endif

#include <fstream>
#include "etseq_app.h"
#include "ftpdef.h"
#include "timer.h"
#include "acceptor.h"

#define TRANSFER_BUFFER_SIZE 4096

enum data_format
{
    Binary, ASCII,
};

class ftplite : public etseq::etseq_srv
{
public:
    ftplite(SOCKET sock, sockaddr_in addr,
            void (*monitor)(euc::thread *, void *) = NULL,
            void *param = NULL);
    virtual ~ftplite(void);

    // ʱʱ˳
    void timeout(void);

    static euc::config_file &get_config(void);
    static unsigned get_default_port(void);

protected:
    // ûӺʾӭϢ
    std::string welcome(bool *result = NULL);
    // ˮʱʾϢ
    std::string poured(bool *result = NULL);
    // û
    std::string parse_line(std::string question, bool *result = NULL);
    // û˳ʱʾϢ
    std::string bye(void);

private:
    // ʱ
    euc::timer<ftplite> *_timer;
    // Դ
    void _cleanup(void);
    // ʽַ
    std::string _format(std::string format, std::string message);
    // ĳɹ
    std::string _successful(std::string number, std::string cmd);
    // 
    std::string _wrong_paramnum(std::string cmd);
    // Ч
    std::string _invalid_command(std::string cmd);
    // ĳҪ¼
    std::string _login_required(std::string cmd);
    // ȡ
    bool _get_data_connection(void);
    // Ŀ¼
    std::string _do_list(std::string cmd, std::string param, bool simple);
    // ϴļ
    bool _store_file(std::fstream &file);
    // Դԡ0 Ϊڣ1 ΪļУ2 Ϊļ
    int _check_existence(std::string path);
    // жָļǷ
    bool _file_exists(std::string path);
    // жָļǷ
    bool _folder_exists(std::string path);

private:
    bool _authorized;       // For login
    bool _anonymous;        // Anonymous user
    std::string _username;  // For login
    std::string _source;    // For rename
    std::string _root_path; // Root path
    std::string _work_path; // Working path

    bool _is_pasv;          // Passive mode
    acceptor *_listener;    // For passive mode
    sockaddr_in _data_addr; // For port mode
    SOCKET _data_sock;      // Data socket

    data_format _type;      // Binary / ASCII
    std::fstream::pos_type
        _rest_pos;          // Rest
    euc::critical_section
        _lock;              // For synchronization

BEGIN_SERVER_HANDLER_TABLE
    SERVER_COMMAND_HANDLER(not_implemented)
    SERVER_COMMAND_HANDLER(on_user)
    SERVER_COMMAND_HANDLER(on_pass)
    SERVER_COMMAND_HANDLER(on_rein)
    SERVER_COMMAND_HANDLER(on_abor)
    SERVER_COMMAND_HANDLER(on_noop)
    SERVER_COMMAND_HANDLER(on_pasv)
    SERVER_COMMAND_HANDLER(on_port)
    SERVER_COMMAND_HANDLER(on_list)
    SERVER_COMMAND_HANDLER(on_nlst)
    SERVER_COMMAND_HANDLER(on_pwd)
    SERVER_COMMAND_HANDLER(on_cwd)
    SERVER_COMMAND_HANDLER(on_cdup)
    SERVER_COMMAND_HANDLER(on_rest)
    SERVER_COMMAND_HANDLER(on_retr)
    SERVER_COMMAND_HANDLER(on_stor)
    SERVER_COMMAND_HANDLER(on_stou)
    SERVER_COMMAND_HANDLER(on_appe)
    SERVER_COMMAND_HANDLER(on_quit)
    SERVER_COMMAND_HANDLER(on_mkd)
    SERVER_COMMAND_HANDLER(on_dele)
    SERVER_COMMAND_HANDLER(on_rnfr)
    SERVER_COMMAND_HANDLER(on_rnto)
    SERVER_COMMAND_HANDLER(on_rmd)
    SERVER_COMMAND_HANDLER(on_type)
    SERVER_COMMAND_HANDLER(on_mode)
    SERVER_COMMAND_HANDLER(on_stru)
    SERVER_COMMAND_HANDLER(on_syst)
    SERVER_COMMAND_HANDLER(on_help)
END_SERVER_HANDLER_TABLE

    static std::string resource(std::string name);
};

#endif // _FTPSRV_APPEARED_
