/*  ftplite 
    Ȩ(C)  2003

    һ GNU ͨù
֤޸ĺ·һ򡣻֤ĵڶ棬ߣѡ
κθµİ汾
    һĿϣãûκεûʺضĿ
ĵĵϸ GNU ͨù֤
    ӦѾͳһյһ GNU ͨù֤ĸûУ
дŸ
    The Free Software Foundation, Inc.,  675  Mass Ave,  Cambridge,
    MA02139,  USA

    ڱʲô⣬ϵ
    E-mailedyfox@sohu.com */
#include "ftplite.h"
#include "ftpver.h"

ftplite::ftplite(SOCKET sock, sockaddr_in addr,
            void (*monitor)(euc::thread *, void *), void *param)
            : etseq::etseq_srv(sock, addr, monitor, param),
            _authorized(false), _is_pasv(true), _listener(NULL),
            _data_sock(INVALID_SOCKET), _type(ASCII), _rest_pos(0)
{
    int timeout = get_config().get_value("Server", "IdleTimeout", 0);
    if (timeout <= 0)
        get_config().set_value("Server", "IdleTimeout", timeout = 30);
    _timer = new euc::timer<ftplite>(timeout, this);
    _timer->start();
}

ftplite::~ftplite(void)
{
    _cleanup();
    _timer->stop();
    _timer->wait();
    delete _timer;
}

// ȡļʵ
euc::config_file &ftplite::get_config(void)
{
    return ((etseq::etseq_app<ftplite> *)
        etseq::get_application())->get_config();
}

// ļδָ˿ڣʹøĬ϶˿
unsigned ftplite::get_default_port(void)
{
    unsigned port = get_config().get_value("Server", "Port", 0);
    if (port == 0)
        get_config().set_value("Server", "Port", (int) (port = 21));
    return port;
}

// û
std::string ftplite::parse_line(std::string question, bool *result)
{
    SYNCHRONIZED(_lock);
    std::string cmd;
    std::string param;
    trace("[%s] %s\n", get_address_string(false).c_str(),
        question.c_str());
    std::string::size_type pos = question.find(' ');

    cmd = euc::to_upper(question.substr(0, pos));
    if (pos != std::string::npos && pos != question.size())
        param = question.substr(pos + 1);

    if (cmd == "")
        return std::string();

    int i;
    for (i = 0; i < map_size; ++i)
    {
        if (cmd == std::string(parser_map[i].cmd))
            break;
    }

    bool return_value = true;
    std::string cmd_result;

    if (i == map_size)
        cmd_result = unhandled(cmd, param, &return_value);
    else
    {
        _timer->reset();
        cmd_result = (this->*parser_map[i].parser)(cmd, param,
            &return_value);
    }

    if (result)
        *result = return_value;

    return cmd_result;
}

// ȡϢ
std::string ftplite::resource(std::string name)
{
    // ļлȡϢ
    std::string message = get_config().get_value("Language", name);

    // ļûжӦĿ
    if (message == "")
    {
        // ȡĬֵ
        int i;
        for (i = 0; i < res_mapsize; ++i)
            if (name == resource_map[i].name)
                break;
        // Ĭֵ
        assert(i != res_mapsize);
        message = resource_map[i].default_value;
    }

    return message;
}

class ftplite_app : public etseq::etseq_app<ftplite>
{
protected:
    bool initialize(void);

#ifdef _USE_RELOAD
    bool reload(void) const;
#endif
};

bool ftplite_app::initialize(void)
{
#ifndef _NO_CONSOLE
    std::cout << "Ftplite " << FTPLITE_VERSION_STRING
        << ", built on " << __DATE__ << std::endl;
#endif
    return etseq::etseq_app<ftplite>::initialize();
}

#ifdef _USE_RELOAD
bool ftplite_app::reload(void) const
{
    trace("Configuration reloaded.\n");
    return get_config().reload();
}
#endif

ftplite_app app;
